package com.ruoyi.system.service;

import java.util.List;
import com.ruoyi.system.domain.TPatient;
import com.ruoyi.system.domain.req.PcTPatintQueryByPageReq;
import com.ruoyi.system.domain.resp.PcTPatientQueryByPageResp;

/**
 * 患者信息Service接口
 *
 * @author ruoyi
 * @date 2022-08-03
 */
public interface ITPatientService
{
    /**
     * 查询患者信息
     *
     * @param id 患者信息主键
     * @return 患者信息
     */
    public TPatient selectTPatientById(Long id);

    /**
     * 查询患者信息列表
     *
     * @param tPatient 患者信息
     * @return 患者信息集合
     */
    public List<TPatient> selectTPatientList(TPatient tPatient);

    /**
     * 新增患者信息
     *
     * @param tPatient 患者信息
     * @return 结果
     */
    public int insertTPatient(TPatient tPatient);

    /**
     * 修改患者信息
     *
     * @param tPatient 患者信息
     * @return 结果
     */
    public int updateTPatient(TPatient tPatient);

    /**
     * 批量删除患者信息
     *
     * @param ids 需要删除的患者信息主键集合
     * @return 结果
     */
    public int deleteTPatientByIds(Long[] ids);

    /**
     * 删除患者信息信息
     *
     * @param id 患者信息主键
     * @return 结果
     */
    public int deleteTPatientById(Long id);

    List<PcTPatientQueryByPageResp> queryByPage(PcTPatintQueryByPageReq pcTPatintQueryByPageReq);

    String checkPhoneUnique(String phone);

    public TPatient queryTPatientByPhoneAndName(TPatient tPatient);
}
